(function ($) {

  /***
   * AJAX
   */
  voterockit_ajax_setup = function () {
    $.ajaxSetup({
      error: function (jqXHR, exception) {
        if (jqXHR.status === 0) {
          alert('Not connect.Verify Network.');
        } else if (jqXHR.status == 404) {
          alert('Requested page not found. [404]');
        } else if (jqXHR.status == 500) {
          alert('Internal Server Error [500].');
        } else if (exception === 'parsererror') {
          alert('Requested JSON parse failed.');
        } else if (exception === 'timeout') {
          alert('Time out error.');
        } else if (exception === 'abort') {
          alert('Ajax request aborted.');
        } else {
          alert('Uncaught Error.\n' + jqXHR.responseText);
        }
      },
      timeout: 60000, //1 minute
      async: false,
      cache: false
    });
  }

  voterockit_load = function (params) {

    voterockit_ajax_setup();

    $.ajax({
      type: (params.type) ? params.type : "POST",
      url: params.url,
      dataType: (params.dataType) ? params.dataType : "html",
      success: function (data, textStatus, jqXHR) {
        if (typeof params.success == 'function') {
          params.success(data);
        }
      },
      data: (params.data) ? params.data : "",
      beforeSend: function (jqXHR, settings) {

        if (params.loaderElement != null) {
          voterockit_loader({
            element: params.loaderElement,
            message: params.beforeSendMessage,
            action: params.loaderAction
          });
        }
      },
      complete: function (jqXHR, settings) {
        if (typeof params.completeCallback == 'function') {
          params.completeCallback();
        }
        if (params.loaderElement != null) {
          $('#voterockit_ajax_loader').remove();
        }
      }
    });
  }

  voterockit_loader = function (param) {

    param = param || {};

    if (typeof param.element != 'undefined') {

      if (typeof param.message == 'undefined') {
        param.message = Drupal.t('processing..');
      }

      if (typeof param.action == 'undefined') {
        param.action = 'insert';
      }

      var path = Drupal.settings.voterockit.abs_path + '/includes/js/ajax.gif';
      var loader = "<div id='voterockit_ajax_loader'><img style='margin-right:3px; vertical-align:middle;' src='" + path + "' /><strong>" + param.message + "</strong></div>";

      if (param.action == 'html') {
        $(param.element).html(loader).css({'padding': '0.5em 1em'});
      }
      else {
        $(loader).css({'padding': '0.5em 1em'}).insertAfter(param.element);
      }
    }
  }

})(jQuery);
