var asInitVals = new Array();

(function ($) {

  $(document).ready(function () {

    $('.voterockit_analytic_delegate').live('click', function (event) {

      event.preventDefault();

      var href = $(this).attr('href');
      var title = $(this).attr('title');

      //change the title
      $('#voterockit_analytic_name h1').html(title);

      voterockit_load({
        dataType: 'json',
        url: href,
        type: 'GET',
        loaderElement: $('#voterockit_analytic_loader'),
        loaderAction: 'html',
        success: voterockit_analytic_success
      });
    });

    $('.voterockit_analytic_delegate.first').trigger('click');

  });//edr

  voterockit_analytic_success = function (response) {

    var chart = $('#voterockit_analytic_chart_display');
    var grid = $('#voterockit_analytic_grid_display');
    var msg = $('#voterockit_analytic_message');
    var actions = $('#voterockit_analytic_actions');
    var state = {'chart': false, 'grid': false};

    if (response.status == 'success') {

      chart.html('');
      grid.html('');
      msg.html('');
      $('button', actions).hide();

      if (response.chart != '') {

        if (typeof response['chart']['tooltip'] !== "undefined") {
          var formatter = response['chart']['tooltip']['formatter'];
          if (formatter != '') {
            response['chart']['tooltip']['formatter'] = eval(formatter);
          }
        }

        if (typeof response['chart']['plotOptions'] !== "undefined") {
          formatter = response['chart']['plotOptions']['pie']['dataLabels']['formatter'];
          if (formatter != '') {
            response['chart']['plotOptions']['pie']['dataLabels']['formatter'] = eval(formatter);
          }
        }

        chart.highcharts(response.chart);
        state.chart = true;
      }

      if (response.grid != '') {

        grid.html(response.grid.grid_footer);
        var oTable = $('#voterockit_analytic_grid').dataTable(response.grid.grid);

        $("tfoot input").keyup(function () {
          oTable.fnFilter(this.value, $("tfoot input").index(this));
        });

        $("tfoot input").each(function (i) {
          asInitVals[i] = this.value;
        });

        $("tfoot input").focus(function () {
          if (this.className == "search_init") {
            this.className = "";
            this.value = "";
          }
        });

        $("tfoot input").blur(function (i) {
          if (this.value == "") {
            this.className = "search_init";
            this.value = asInitVals[$("tfoot input").index(this)];
          }
        });

        state.grid = true;

        $('.voterockit_analytic_gears_photo').bind('hover', function (event) {
          $(this).popover({
            content: '<img src="' + $(this).attr('content') + '" />',
            html: true,
            trigger: 'hover',
            placement: 'left',
            title: 'Gear Image'
          });
          $(this).popover('toggle');
        });
      }

      if (state.grid == true && state.chart == true) {

        $('#voterockit_analytic_chart_button').bind('click',function () {
          grid.hide();
          chart.show('blind');
        }).show();

        $('#voterockit_analytic_grid_button').bind('click',function () {
          chart.hide();
          grid.show('blind');
        }).show();
      }
      else if (state.grid == true && state.chart == false) {
        chart.hide();
        grid.show('blind');
      }
      else if (state.grid == false && state.chart == true) {
        grid.hide();
        chart.show('blind');
      }
    }
    else {
      msg.html('<div class="alert alert-error"><button type="button" class="close" data-dismiss="alert">&times;</button><h4>Error!</h4>' + response.message + '</div>').show();
    }
  }

  voterockit_analytic_per_day_tootltip = function () {

    var dstring = this.x;
    dstring = dstring.split('-');
    dstring = new Date(dstring[0], parseInt(dstring[1]) - 1, dstring[2], 0, 0, 0);
    dstring = dstring.toDateString();
    if (this.series.name == 'Donations') {
      return '<b>' + dstring + '</b><br />' + this.series.name + ': $' + this.y;
    }
    else {
      return '<b>' + dstring + '</b><br />' + this.series.name + ': ' + this.y;
    }

  };

  voterockit_analytic_voter_formatter = function () {
    return '<b>' + this.point.name + '</b>: ' + this.point.y;
  };

})(jQuery);
