<?php
/**
 * add js and css for colorpick plugin
 */
function add_colorpick_file() {

  //add required files for colorpicker implementation
  drupal_add_css(VOTEROCKIT_CONFIG_PATH . '/includes/colorpicker/css/colorpicker.min.css', array(
    'group' => CSS_DEFAULT,
    'type'  => 'file'
  ));

  drupal_add_js(BASE_URL . VOTEROCKIT_CONFIG_PATH . '/includes/colorpicker/js/colorpicker.min.js', array(
    'group' => JS_DEFAULT,
    'type'  => 'file'
  ));
}

/**
 * VoteRockIt application configuration form
 * @see voterockit_app_configure_form_submit
 *
 */
function voterockit_app_configure_form($form, &$form_state) {

  voterockit_add_style_script();

  drupal_add_js(BASE_URL . VOTEROCKIT_CONFIG_PATH . '/includes/js/voterockit_config.js', array(
    'group' => JS_DEFAULT,
    'type'  => 'file'
  ));

  drupal_add_js(BASE_URL . VOTEROCKIT_PATH . '/includes/js/popup.js', array(
    'group' => JS_DEFAULT,
    'type'  => 'file'
  ));

  include_voterockit_field('voterockit_config');
  add_colorpick_file();

  $data = array();
  $voterockit_configuration = array();
  $voterockit_campaign = array();

  //get saved data
  $record = db_query("SELECT * FROM {voterockit_config} LIMIT 1")->fetchObject();

  if (!empty($record->data)) {
    $data = unserialize($record->data);
    $voterockit_configuration = get_voterockit_config_parse_value(VOTEROCKIT_CONFIGURATION, $data);
    $voterockit_campaign = get_voterockit_config_parse_value(VOTEROCKIT_CAMPAIGN, $data);
  }

  $form ['#attributes'] = array('enctype' => "multipart/form-data");

  $form['config_id'] = array(
    '#type'  => 'hidden',
    '#value' => $record->parse_id,
  );

  $form['campaign_id'] = array(
    '#type'  => 'hidden',
    '#value' => $record->campaign_id,
  );

  $form['id'] = array(
    '#type'  => 'hidden',
    '#value' => $record->id,
  );

  $form['voterockit_config'] = array(
    '#type' => 'vertical_tabs',
  );

  $form['voterockit']['options'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('Options'),
    '#collapsible' => FALSE,
    '#collapsed'   => FALSE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['options']['show_donate'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Donate in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_donate'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_events'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Events in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_events'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_issues'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Issues in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_issues'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_news'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show News in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_news'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_videos'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Videos in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_videos'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_volunteer'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Volunteer in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_volunteer'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['options']['show_gear'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Campaign Merchandise in VoteRockIt App'),
    '#default_value' => $voterockit_configuration['show_gear'],
    '#group'         => 'voterockit_config',
  );

  $form['voterockit']['images'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('IMAGES'),
    '#collapsible' => FALSE,
    '#collapsed'   => FALSE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['images']['logo'] = array(
    '#type'               => 'managed_file',
    '#title'              => t('Choose a logo'),
    '#progress_indicator' => 'bar',
    '#group'              => 'voterockit_config',
    '#description'        => t("Allowed extensions: <strong>png</strong>|") . '<span id="logo_example" class="label label-important" style="cursor:pointer; margin-left:10px" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Logo Image') . '</span>',
    '#upload_location'    => "public://voterockit/config/",
    '#upload_validators'  => array(
      'file_validate_extensions' => array('png'),
      //'file_validate_image_resolution' => array('44x260'),
    ),
  );

  $form['voterockit']['images']['logo_url'] = array(
    '#type'  => 'hidden',
    '#value' => $voterockit_configuration['logo'],
  );

  if (!empty($record->id)) {

    $form['voterockit']['images']['logo_preview'] = array(
      '#markup' => '<p><span style="cursor:pointer" id="logo_preview" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover" class="label label-info">' . t('Saved Logo') . '</span></p>',
    );
  }

  $form['voterockit']['images']['volunteer_photo'] = array(
    '#type'               => 'managed_file',
    '#title'              => t('Volunteer Image'),
    '#group'              => 'voterockit_config',
    '#progress_indicator' => 'bar',
    '#description'        => t("Allowed extensions: <strong>png jpg jpeg</strong>|") . '<span id="volunteer_photo_example" class="label label-important" style="cursor:pointer; margin-left:10px" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Volunteer Image') . '</span>',
    '#upload_location'    => "public://voterockit/config/",
    '#upload_validators'  => array(
      'file_validate_extensions' => array('png jpg jpeg'),
    ),
  );

  $form['voterockit']['images']['volunteer_photo_url'] = array(
    '#type'  => 'hidden',
    '#value' => $voterockit_configuration['volunteer_photo'],
  );

  if (!empty($record->id)) {

    $form['voterockit']['images']['volunteer_photo_preview'] = array(
      '#markup' => '<p><span style="cursor:pointer" id="volunteer_photo_preview" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover" class="label label-info">' . t('Saved Volunteer Photo') . '</span></p>',
    );
  }
  else {

  }

  $form['voterockit']['images']['get_to_know_photo'] = array(
    '#type'               => 'managed_file',
    '#title'              => t('Main Issue Image'),
    '#group'              => 'voterockit_config',
    '#progress_indicator' => 'bar',
    '#description'        => t("Allowed extensions: <strong>png jpg jpeg</strong>|") . '<span id="get_to_know_photo_example" class="label label-important" style="cursor:pointer; margin-left:10px" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Main Issue Image') . '</span>',
    '#upload_location'    => "public://voterockit/config/",
    '#upload_validators'  => array(
      'file_validate_extensions' => array('png jpg jpeg'),
    ),
  );

  $form['voterockit']['images']['get_to_know_photo_url'] = array(
    '#type'  => 'hidden',
    '#value' => $voterockit_configuration['get_to_know_photo'],
  );

  if (!empty($record->id)) {

    $form['voterockit']['images']['get_to_know_photo_preview'] = array(
      '#markup' => '<p><span style="cursor:pointer" id="get_to_know_photo_preview" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover" class="label label-info">' . t('Saved Main Issue Image') . '</span></p>',
    );
  }

  $form['voterockit']['localization'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('CUSTOM TEXT'),
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['localization']['localization_file'] = array(
    '#type'               => 'managed_file',
    '#title'              => t('Custom Text'),
    '#group'              => 'voterockit_config',
    '#progress_indicator' => 'bar',
    '#description'        => t("Allowed extensions: <strong>strings</strong>|") . '<a href="' . url('voterockit/download', array('query' => array('file' => base_path() . VOTEROCKIT_PATH . '/includes/misc/Localizable.strings'))) . '" id="download_example_custom_text"><span class="label label-important" style="cursor:pointer; margin-left:10px">Download</span></a> the example Localization.strings file and make changes text on the right side of the "=" sign. Upload it here and the text will change inside your VoteRockIt app.',
    '#upload_location'    => "public://voterockit/config/",
    '#upload_validators'  => array(
      'file_validate_extensions' => array('strings'),
    ),
  );

  $form['voterockit']['localization']['localization_file_url'] = array(
    '#type'  => 'hidden',
    '#value' => $voterockit_configuration['localization_file'],
  );

  if (!empty($record->id)) {

    $form['voterockit']['localization']['localization_file_preview'] = array(
      '#markup' => '<p>' . l(t('Saved Custom Text'), $voterockit_configuration['localization_file'], array(
        'attributes' => array(
          'target' => '_blank',
          'class'  => 'label label-info'
        )
      )) . '</p>',
    );
  }

  $form['voterockit']['theme_color'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('THEME COLOR'),
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['theme_color']['main_color'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Main Color"),
    '#description'   => '<span id="main_color_example" class="label label-important" style="cursor:pointer" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Main Color') . '</span>',
    '#size'          => 30,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_configuration['main_color'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['theme_color']['highlight_color'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Highlight Color"),
    '#description'   => '<span id="hightlight_color_example" class="label label-important" style="cursor:pointer" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Highlight Color') . '</span>',
    '#size'          => 30,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_configuration['highlight_color'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['theme_color']['accent_color'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Accent Color"),
    '#description'   => '<span id="accent_color_example" class="label label-important" style="cursor:pointer" data-trigger="hover" data-html="true" data-placement="right" data-toggle="popover">' . t('Example Accent Color') . '</span>',
    '#size'          => 30,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_configuration['accent_color'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['donate'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('DONATE'),
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['donate']['stripe_secret'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Stripe Secret"),
    '#description'   => t(""),
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_configuration['stripe_secret'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['donate']['stripe_publish_key'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Stripe Publish Key"),
    '#description'   => t(""),
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_configuration['stripe_publish_key'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['donate']['stripe_signup'] = array(
    '#markup' => '<p><a target="_blank" href="https://manage.stripe.com/register"><span class="label label-info">' . t('Signup for Stripe') . '</span></a>&nbsp;&nbsp;<a id="get_stripe_key" href="#get_stripe_key_content"><span class="label label-important">' . t('Getting your Stripe API Key') . '</span></a></p><div id="get_stripe_key_content" style="display:none;"><img src="' . BASE_URL . VOTEROCKIT_PATH . '/includes/misc/stripe_instruction.png' . '" /></div>',
  );

  $form['voterockit']['campaign'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('CAMPAIGN'),
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['campaign']['campaign_header'] = array(
    '#markup' => '<p class="alert alert-info"><strong>' . t('Election date is used by the app to remind users to vote. Candidate Name is displayed throughout the app. Campaign information is used to tell users where to send emails or where to contact the campaign') . '</strong></p>',
  );

  $election_date = $voterockit_configuration['election_date'];
  if (!empty($election_date['iso'])) {
    $election_date = date('Y-m-d', strtotime($election_date['iso']));
  }
  else {
    $election_date = date('Y-m-d', time());
  }

  $form['voterockit']['campaign']['election_date'] = array(
    '#type'                => 'date_popup',
    '#title'               => t('Election Date'),
    '#default_value'       => $election_date,
    '#date_format'         => 'Y-m-d',
    '#date_label_position' => 'within',
    //'#date_timezone' => 'America/Chicago',
    '#date_increment'      => 15,
    '#date_year_range'     => '-3:+3',
    '#required'            => TRUE,
    '#group'               => 'voterockit_config',
  );

  $form['voterockit']['campaign']['candidate_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Candidate Name"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['candidate_name'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_email'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Campaign Email"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['campaign_email'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_phone'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Campaign Phone"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['campaign_phone'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_city'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Campaign City"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['campaign_city'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_state'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Campaign State"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['campaign_state'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_zip'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Campaign Zip"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['campaign_zip'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['campaign']['campaign_address'] = array(
    '#type'          => 'textarea',
    '#cols'          => 20,
    '#title'         => t("Campaign Address"),
    '#description'   => '',
    '#default_value' => $voterockit_campaign['campaign_address'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact'] = array(
    '#type'        => 'fieldset',
    '#title'       => t('CONTACT'),
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
    '#group'       => 'voterockit_config',
  );

  $form['voterockit']['contact']['contact_header'] = array(
    '#markup' => '<p class="alert alert-info"><strong>' . t('This is contact information for VoteRockIt to use to contact you. This is not used in your VoteRockIt app.') . '</strong></p>',
  );

  $form['voterockit']['contact']['contact_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact Name"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_name'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_email'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact Email"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_email'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_phone'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact Phone"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_phone'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_city'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact City"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_city'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_state'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact State"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_state'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_zip'] = array(
    '#type'          => 'textfield',
    '#title'         => t("Contact Zip"),
    '#description'   => '',
    '#size'          => 60,
    '#maxlength'     => 255,
    '#default_value' => $voterockit_campaign['contact_zip'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['voterockit']['contact']['contact_address'] = array(
    '#type'          => 'textarea',
    '#cols'          => 20,
    '#title'         => t("Contact Address"),
    '#description'   => '',
    '#default_value' => $voterockit_campaign['contact_address'],
    '#group'         => 'voterockit_config',
    '#required'      => TRUE,
  );

  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Save'),
  );

  return $form;

}

/**
 * validate handler for VoteRockIt application configuration form
 * @see voterockit_app_configure_form
 *
 */
function voterockit_app_configure_form_validate($form, &$form_state) {

  $form_state['values'] = voterockit_trim($form_state['values']);

  $form_state['values']['main_color'] = check_plain($form_state['values']['main_color']);
  $form_state['values']['highlight_color'] = check_plain($form_state['values']['highlight_color']);
  $form_state['values']['accent_color'] = check_plain($form_state['values']['accent_color']);
  $form_state['values']['stripe_secret'] = check_plain($form_state['values']['stripe_secret']);
  $form_state['values']['stripe_publish_key'] = check_plain($form_state['values']['stripe_publish_key']);
  $form_state['values']['election_date'] = check_plain($form_state['values']['election_date']);
  $form_state['values']['candidate_name'] = check_plain($form_state['values']['candidate_name']);
  $form_state['values']['campaign_phone'] = check_plain($form_state['values']['campaign_phone']);
  $form_state['values']['campaign_city'] = check_plain($form_state['values']['campaign_city']);
  $form_state['values']['campaign_state'] = check_plain($form_state['values']['campaign_state']);
  $form_state['values']['campaign_zip'] = check_plain($form_state['values']['campaign_zip']);
  $form_state['values']['campaign_address'] = check_plain($form_state['values']['campaign_address']);
  $form_state['values']['contact_name'] = check_plain($form_state['values']['contact_name']);
  $form_state['values']['contact_phone'] = check_plain($form_state['values']['contact_phone']);
  $form_state['values']['contact_city'] = check_plain($form_state['values']['contact_city']);
  $form_state['values']['contact_state'] = check_plain($form_state['values']['contact_state']);
  $form_state['values']['contact_zip'] = check_plain($form_state['values']['contact_zip']);
  $form_state['values']['contact_address'] = check_plain($form_state['values']['contact_address']);

  $post = $form_state['values'];

  //validate email
  if (!empty($post['campaign_email']) && !valid_email_address($post['campaign_email'])) {
    form_set_error('campaign_email', t('Campaign email is not valid email address'));
  }

  if (!empty($post['contact_email']) && !valid_email_address($post['contact_email'])) {
    form_set_error('contact_email', t('Contact email is not valid email address'));
  }

  //validate files
  if (empty($post['logo']) && empty($post['logo_url'])) {
    form_set_error('logo', t('Logo field is required.'));
  }

  if (empty($post['volunteer_photo']) && empty($post['volunteer_photo_url'])) {
    form_set_error('volunteer_photo', t('Volunteer Photo field is required.'));
  }

  if (empty($post['get_to_know_photo']) && empty($post['get_to_know_photo_url'])) {
    form_set_error('get_to_know_photo', t('Get To Know Photo field is required.'));
  }

  if (empty($post['localization_file']) && empty($post['localization_file_url'])) {
    form_set_error('localization_file', t('Localization File field is required.'));
  }

}

/**
 * submit handler for VoteRockIt application configuration form
 * @see voterockit_app_configure_form
 *
 */
function voterockit_app_configure_form_submit($form, &$form_state) {

  include_voterockit_field('voterockit_config');

  $messages = array();

  $message_type = 'error';

  $post = $form_state['values'];

  //get image files
  if (!empty($post['logo'])) {
    $file = file_load($post['logo']);
    $post['logo'] = drupal_realpath($file->uri);
  }

  if (!empty($post['volunteer_photo'])) {
    $file = file_load($post['volunteer_photo']);
    $post['volunteer_photo'] = drupal_realpath($file->uri);
  }

  if (!empty($post['get_to_know_photo'])) {
    $file = file_load($post['get_to_know_photo']);
    $post['get_to_know_photo'] = drupal_realpath($file->uri);
  }

  if (!empty($post['localization_file'])) {
    $file = file_load($post['localization_file']);
    $post['localization_file'] = drupal_realpath($file->uri);
  }

  //date field
  if (!empty($post['election_date'])) {
    $post['election_date'] = strtotime($post['election_date']);
  }

  $campaign = voterockit_config_campaign_save($post);

  if (!empty($campaign)) {

    $config = voterockit_config_configuration_save($campaign['objectId'], $post);

    if (!empty($config)) {

      if (empty($post['id'])) {
        $id = db_insert('voterockit_config')
          ->fields(array(
            'parse_id'    => $config['objectId'],
            'campaign_id' => $campaign['objectId'],
            'data'        => serialize(array(
              VOTEROCKIT_CAMPAIGN      => $campaign,
              VOTEROCKIT_CONFIGURATION => $config,
            )),
          ))
          ->execute();
      }
      else {
        $id = db_update('voterockit_config')
          ->fields(array(
            'data' => serialize(array(
              VOTEROCKIT_CAMPAIGN      => $campaign,
              VOTEROCKIT_CONFIGURATION => $config,
            )),
          ))
          ->condition('id', $post['id'], '=')
          ->execute();
      }
    }
    else {
      $messages[] = t('Error adding data to !class object', array('!class' => VOTEROCKIT_CONFIGURATION));
    }
  }
  else {
    $messages[] = t('Error adding data to !class object', array('!class' => VOTEROCKIT_CAMPAIGN));
  }

  if (empty($messages)) {
    $messages[] = t('Configuration settings have been saved.');
    $message_type = 'status';
  }

  drupal_set_message(implode('<br>', $messages), $message_type);
}

/**
 * save configuration data to Account object
 *
 * @param array
 *
 * @return account object
 *
 */
function voterockit_config_campaign_save($data) {

  $campaign_data = voterockit_set_field_value(get_voterockit_config_campaign_fields(), $data);
  $campaign = create_voterockit_object(VOTEROCKIT_CAMPAIGN);

  if (empty($data['campaign_id'])) {
    $response = $campaign->add($campaign_data);
  }
  else {
    $campaign_data['objectId'] = $data['campaign_id'];
    $response = $campaign->update($campaign_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {
    return $result['message'];
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_CAMPAIGN . ', [DATA]: %data', array('%data' => $campaign->voterockitErrors), WATCHDOG_EMERGENCY);

  return NULL;
}

/**
 * save configuration data to Configuration object
 *
 * @param array
 *
 * @return configuration object
 *
 */
function voterockit_config_configuration_save($campaign_id, $data) {

  $data['campaign'] = $campaign_id;

  $config_data = voterockit_set_field_value(get_voterockit_config_configuration_fields(), $data);

  $config = create_voterockit_object(VOTEROCKIT_CONFIGURATION);

  if (empty($data['config_id'])) {
    $response = $config->add($config_data);
  }
  else {
    $config_data['objectId'] = $data['config_id'];
    $response = $config->update($config_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {
    return $result['message'];
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_CONFIGURATION . ', [DATA]: %data', array('%data' => $config->voterockitErrors), WATCHDOG_EMERGENCY);

  return NULL;
}
