<?php

/**
 * @return array Configuration data object fields mapping
 */
function get_voterockit_config_configuration_fields() {

  return array(
    array(
      'parse_field'   => 'campaign',
      'field'         => 'campaign',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'pointer',
      'class_name'    => 'Campaign',
    ),
    array(
      'parse_field'   => 'logo',
      'field'         => 'logo',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'volunteerPhoto',
      'field'         => 'volunteer_photo',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'getToKnowPhoto',
      'field'         => 'get_to_know_photo',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'localizationFile',
      'field'         => 'localization_file',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'themeMainColor',
      'field'         => 'main_color',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'themeHighlightColor',
      'field'         => 'highlight_color',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'themeAccentColor',
      'field'         => 'accent_color',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'stripeKey',
      'field'         => 'stripe_secret',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'stripePublishKey',
      'field'         => 'stripe_publish_key',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'lastConfigurationChangeDate',
      'field'         => '',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'electionDate',
      'field'         => 'election_date',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'showDonate',
      'field'         => 'show_donate',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showEvents',
      'field'         => 'show_events',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showIssues',
      'field'         => 'show_issues',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showNews',
      'field'         => 'show_news',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showVideos',
      'field'         => 'show_videos',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showVolunteer',
      'field'         => 'show_volunteer',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'showGear',
      'field'         => 'show_gear',
      'field_type'    => 'single',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
  );
}

/**
 * @return array Campaign data object fields
 */
function get_voterockit_config_campaign_fields() {

  return array(
    array(
      'parse_field'   => 'candidateName',
      'field'         => 'candidate_name',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignEmail',
      'field'         => 'campaign_email',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignPhone',
      'field'         => 'campaign_phone',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignCity',
      'field'         => 'campaign_city',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignState',
      'field'         => 'campaign_state',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignZip',
      'field'         => 'campaign_zip',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'campaignAddress',
      'field'         => 'campaign_address',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'contactName',
      'field'         => 'contact_name',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'contactEmail',
      'field'         => 'contact_email',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'phone',
      'field'         => 'contact_phone',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'city',
      'field'         => 'contact_city',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'state',
      'field'         => 'contact_state',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'zip',
      'field'         => 'contact_zip',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'address',
      'field'         => 'contact_address',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
  );
}

/**
 * @param string $class parse class name
 * @param string $field parse field name
 * @param array $data
 *
 * @return string value
 */
function get_voterockit_config_parse_value($class, $data) {

  $output = array();
  $class = strtolower($class);

  $array = call_user_func('get_voterockit_config_' . $class . '_fields');

  foreach ($array as $field) {

    switch ($field['type']) {

      case 'file':
        $value = $data[$class][$field['parse_field']]['url'];
        break;
      default:
        $value = $data[$class][$field['parse_field']];
    }

    $return[$field['field']] = $value;

  }

  return $return;
}
