<?php

/**
 * @return array Blog=>Post data object fields mapping
 */
function get_voterockit_content_blog_fields() {

  return array(
    array(
      'parse_field'   => 'author',
      'field'         => 'name',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'body',
      'field'         => 'body|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'publishDate',
      'field'         => 'created',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'shareEnabled',
      'field'         => 'field_shared|und|0|value',
      'field_type'    => 'multi',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'shortDescription',
      'field'         => 'body|und|0|summary',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'title',
      'field'         => 'title',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'status',
      'field'         => 'status',
      'field_type'    => 'single',
      'default_value' => 'unpublished',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'type',
      'field'         => 'parse_type',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'hero',
      'field'         => 'field_image|und|0|uri',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'link',
      'field'         => 'field_link',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
  );
}

/**
 * @return array Blog=>Post data object fields mapping
 */
function get_voterockit_content_video_fields() {

  return array(
    array(
      'parse_field'   => 'author',
      'field'         => 'name',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'body',
      'field'         => 'body|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'publishDate',
      'field'         => 'created',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'shareEnabled',
      'field'         => 'field_shared|und|0|value',
      'field_type'    => 'multi',
      'default_value' => 0,
      'type'          => 'boolean'
    ),
    array(
      'parse_field'   => 'shortDescription',
      'field'         => 'body|und|0|summary',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'title',
      'field'         => 'title',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'status',
      'field'         => 'status',
      'field_type'    => 'single',
      'default_value' => 'unpublished',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'type',
      'field'         => 'parse_type',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'hero',
      'field'         => 'field_video_thumbnail|und|0|uri',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'video',
      'field'         => 'field_video|und|0|uri',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'file'
    ),
  );
}

/**
 * @return array Event data object fields mapping
 */
function get_voterockit_content_event_fields() {

  return array(
    array(
      'parse_field'   => 'endDate',
      'field'         => 'field_event_date|und|0|value2',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'eventDescription',
      'field'         => 'body|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'eventImage',
      'field'         => 'field_image|und|0|uri',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'shortDescription',
      'field'         => 'body|und|0|summary',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'startDate',
      'field'         => 'field_event_date|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'date'
    ),
    array(
      'parse_field'   => 'status',
      'field'         => 'field_event_status|und|0|value',
      'field_type'    => 'multi',
      'default_value' => 'closed',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'title',
      'field'         => 'title',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'eventAddress',
      'field'         => 'field_event_address|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'string'
    ),
  );
}

/**
 * @return array Gear data object fields mapping
 */
function get_voterockit_content_gear_fields() {

  return array(
    array(
      'parse_field'   => 'title',
      'field'         => 'title',
      'field_type'    => 'single',
      'default_value' => '',
      'type'          => 'string'
    ),
    array(
      'parse_field'   => 'photo',
      'field'         => 'field_image|und|0|uri',
      'field_type'    => 'multi',
      'default_value' => '',
      'type'          => 'file'
    ),
    array(
      'parse_field'   => 'price',
      'field'         => 'field_price|und|0|value',
      'field_type'    => 'multi',
      'default_value' => '0',
      'type'          => 'integer'
    ),
  );
}
