<?php
/**
 * perform add/update action for type = blog
 *
 * @param object $node
 *
 * @return array
 */
function voterockit_content_blog_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_file = FALSE;

  if (!empty($node->field_image['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_image['und']['0']['fid'] != $node->field_image['original']['und']['0']['fid']) {
        $can_load_file = TRUE;
      }
    }
    else {
      $can_load_file = TRUE;
    }
  }

  if ($can_load_file == TRUE) {
    $file = file_load($node->field_image['und']['0']['fid']);
    $node->field_image['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  if ($node->status == '1') {
    $node->status = 'published';
  }

  //add link
  $node->field_link = url('node/' . $node->nid, array('absolute' => TRUE));

  $post_data = voterockit_set_field_value(get_voterockit_content_blog_fields(), (array) $node);

  $post = create_voterockit_object(VOTEROCKIT_POST);

  if ($action == 'update') {

    $post_data['objectId'] = $node->voterockit_parse_id;
    $response = $post->update($post_data);
  }
  else {

    $response = $post->add($post_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_POST => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_POST . ', [DATA]: %data', array('%data' => $post->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );

}

/**
 * perform add/update action for type = event
 *
 * @param array $data
 *
 * @return array
 */
function voterockit_content_event_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_file = FALSE;

  if (!empty($node->field_image['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_image['und']['0']['fid'] != $node->field_image['original']['und']['0']['fid']) {
        $can_load_file = TRUE;
      }
    }
    else {
      $can_load_file = TRUE;
    }
  }

  if ($can_load_file == TRUE) {
    $file = file_load($node->field_image['und']['0']['fid']);
    $node->field_image['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  $event_data = voterockit_set_field_value(get_voterockit_content_event_fields(), (array) $node);

  $event = create_voterockit_object(VOTEROCKIT_EVENT);

  if ($action == 'update') {

    $event_data['objectId'] = $node->voterockit_parse_id;
    $response = $event->update($event_data);
  }
  else {

    $response = $event->add($event_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_EVENT => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_EVENT . ', [DATA]: %data', array('%data' => $event->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );
}


/**
 * perform add/update action for type = gear
 *
 * @param array $data
 *
 * @return array
 */
function voterockit_content_gear_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_file = FALSE;

  if (!empty($node->field_image['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_image['und']['0']['fid'] != $node->field_image['original']['und']['0']['fid']) {
        $can_load_file = TRUE;
      }
    }
    else {
      $can_load_file = TRUE;
    }
  }

  if ($can_load_file == TRUE) {
    $file = file_load($node->field_image['und']['0']['fid']);
    $node->field_image['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  $gear_data = voterockit_set_field_value(get_voterockit_content_gear_fields(), (array) $node);

  $gear = create_voterockit_object(VOTEROCKIT_GEAR);

  if ($action == 'update') {

    $gear_data['objectId'] = $node->voterockit_parse_id;
    $response = $gear->update($gear_data);
  }
  else {

    $response = $gear->add($gear_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_GEAR => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_GEAR . ', [DATA]: %data', array('%data' => $gear->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );
}

/**
 * perform add/update action for type = article
 *
 * @param object $node
 *
 * @return array
 */
function voterockit_content_article_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_file = FALSE;

  if (!empty($node->field_image['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_image['und']['0']['fid'] != $node->field_image['original']['und']['0']['fid']) {
        $can_load_file = TRUE;
      }
    }
    else {
      $can_load_file = TRUE;
    }
  }

  if ($can_load_file == TRUE) {
    $file = file_load($node->field_image['und']['0']['fid']);
    $node->field_image['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  if ($node->status == '1') {
    $node->status = 'published';
  }

  //add link
  $node->field_link = url('node/' . $node->nid, array('absolute' => TRUE));

  $article_data = voterockit_set_field_value(get_voterockit_content_blog_fields(), (array) $node);

  $post = create_voterockit_object(VOTEROCKIT_POST);

  if ($action == 'update') {

    $article_data['objectId'] = $node->voterockit_parse_id;
    $response = $post->update($article_data);
  }
  else {

    $response = $post->add($article_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_POST => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_POST . ', [DATA]: %data', array('%data' => $post->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );

}

/**
 * perform add/update action for type = issue
 *
 * @param object $node
 *
 * @return array
 */
function voterockit_content_issue_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_file = FALSE;

  if (!empty($node->field_image['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_image['und']['0']['fid'] != $node->field_image['original']['und']['0']['fid']) {
        $can_load_file = TRUE;
      }
    }
    else {
      $can_load_file = TRUE;
    }
  }

  if ($can_load_file == TRUE) {
    $file = file_load($node->field_image['und']['0']['fid']);
    $node->field_image['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  if ($node->status == '1') {
    $node->status = 'published';
  }

  //add link
  $node->field_link = url('node/' . $node->nid, array('absolute' => TRUE));

  $issue_data = voterockit_set_field_value(get_voterockit_content_blog_fields(), (array) $node);

  $post = create_voterockit_object(VOTEROCKIT_POST);

  if ($action == 'update') {

    $issue_data['objectId'] = $node->voterockit_parse_id;
    $response = $post->update($issue_data);
  }
  else {

    $response = $post->add($issue_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_POST => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_POST . ', [DATA]: %data', array('%data' => $post->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );

}

/**
 * perform add/update action for type = video
 *
 * @param object $node
 *
 * @return array
 */
function voterockit_content_video_save($node, $action = 'add') {

  include_voterockit_field('voterockit_content');

  $can_load_thumbnail_file = FALSE;
  $can_load_video_file = FALSE;

  if (!empty($node->field_video['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_video['und']['0']['fid'] != $node->field_video['original']['und']['0']['fid']) {
        $can_load_video_file = TRUE;
      }
    }
    else {
      $can_load_video_file = TRUE;
    }
  }

  if (!empty($node->field_video_thumbnail['und']['0']['fid'])) {

    if ($action == 'update') {

      if ($node->field_video_thumbnail['und']['0']['fid'] != $node->field_video_thumbnail['original']['und']['0']['fid']) {
        $can_load_thumbnail_file = TRUE;
      }
    }
    else {
      $can_load_thumbnail_file = TRUE;
    }
  }

  if ($can_load_video_file == TRUE) {
    $file = file_load($node->field_video['und']['0']['fid']);
    $node->field_video['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  if ($can_load_thumbnail_file == TRUE) {
    $file = file_load($node->field_video_thumbnail['und']['0']['fid']);
    $node->field_video_thumbnail['und']['0']['uri'] = drupal_realpath($file->uri);
  }

  if ($node->status == '1') {
    $node->status = 'published';
  }

  $video_data = voterockit_set_field_value(get_voterockit_content_video_fields(), (array) $node);

  $post = create_voterockit_object(VOTEROCKIT_POST);

  if ($action == 'update') {

    $video_data['objectId'] = $node->voterockit_parse_id;
    $response = $post->update($video_data);
  }
  else {

    $response = $post->add($video_data);
  }

  $result = json_decode($response['result'], TRUE);

  if ($result['status'] == 'success') {

    return array(
      'status'   => TRUE,
      'parse_id' => $result['message']['objectId'],
      'data'     => serialize(array(
        VOTEROCKIT_POST => $result['message'],
      )),
    );
  }

  watchdog('voterockit', '[CLASS]: ' . VOTEROCKIT_POST . ', [DATA]: %data', array('%data' => $post->voterockitErrors), WATCHDOG_EMERGENCY);

  return array(
    'status' => FALSE,
  );

}
